/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// AssetMediaSource the model 'AssetMediaSource'
type AssetMediaSource string

// List of AssetMediaSource
const (
	AssetMediaSourceUrl AssetMediaSource = "url"
	AssetMediaSourceFile AssetMediaSource = "file"
)

// All allowed values of AssetMediaSource enum
var AllowedAssetMediaSourceEnumValues = []AssetMediaSource{
	"url",
	"file",
}

func (v *AssetMediaSource) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := AssetMediaSource(value)
	for _, existing := range AllowedAssetMediaSourceEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid AssetMediaSource", value)
}

// NewAssetMediaSourceFromValue returns a pointer to a valid AssetMediaSource
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewAssetMediaSourceFromValue(v string) (*AssetMediaSource, error) {
	ev := AssetMediaSource(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for AssetMediaSource: valid values are %v", v, AllowedAssetMediaSourceEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v AssetMediaSource) IsValid() bool {
	for _, existing := range AllowedAssetMediaSourceEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to AssetMediaSource value
func (v AssetMediaSource) Ptr() *AssetMediaSource {
	return &v
}

type NullableAssetMediaSource struct {
	value *AssetMediaSource
	isSet bool
}

func (v NullableAssetMediaSource) Get() *AssetMediaSource {
	return v.value
}

func (v *NullableAssetMediaSource) Set(val *AssetMediaSource) {
	v.value = val
	v.isSet = true
}

func (v NullableAssetMediaSource) IsSet() bool {
	return v.isSet
}

func (v *NullableAssetMediaSource) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAssetMediaSource(val *AssetMediaSource) *NullableAssetMediaSource {
	return &NullableAssetMediaSource{value: val, isSet: true}
}

func (v NullableAssetMediaSource) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAssetMediaSource) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

